///////////////////////////////////////////////////////////////////////////////
// Project: defectix 
// Filename: computer.hh
// Directory: src
///////////////////////////////////////////////////////////////////////////////
// Authors: A. BAILLARD
// Creation date: 22/03/04
// Last modification date: 22/03/04
///////////////////////////////////////////////////////////////////////////////
// Comments:
// 22/03/04	Creation
///////////////////////////////////////////////////////////////////////////////

#ifndef COMPUTING_HH_
# define COMPUTING_HH_

# include <iostream>
# include <map>
// # include <cc++/thread.h>
# include "defectix.hh"

#ifdef  CCXX_NAMESPACES
using namespace std;
using namespace ost;
#endif

extern "C"
{
#  include "network.h"
}

using namespace DefectixError;

class DefectComputer : public Defectix
{
public:
  /////////////////////////////////////////////////////////////////////////////
  // functions in trainer.cc		       				     //
  /////////////////////////////////////////////////////////////////////////////
  DefectComputer(const DefectixOptions::Options& options);

public:
  const errorCodes	exec();

public:
  const errorCodes	loadNetworks();

private:
  const errorCodes	createOutputImage(std::map<int, gsl_matrix_float*>& src,
					  std::map<int, gsl_matrix_float*>& dest,
					  FitsManager& mgr,
					  gsl_matrix_float *evec);

  gsl_matrix_float		*loadKLBase();

private:  
  t_network	*_l0;
  t_network	*_l1;
  int		_nbPC;
  std::string	_evecFile;
  std::string	_nnFile;
  bool		_printRebuilt;
  double	_treshold;

  /////////////////////////////////////////////////////////////////////////////
  // multi-threading			       				     //
  /////////////////////////////////////////////////////////////////////////////
//   Conditional	_c;
};

#endif /* !COMPUTING_HH_ */
