/******************************************************************************
** Project: neural_network
** Filename: common.c
*******************************************************************************
** Authors: A. BAILLARD & T. BAUDLOT
** Creation date: 01/07/03
** Last modification date:
*******************************************************************************
** Comments:
** 01/07/03	AB	Defines common functions
**				- xmalloc()
**
******************************************************************************/

#ifndef COMMON_H_
# define COMMON_H_

# define LIBNN_NO_ERROR		0
# define LIBNN_MALLOC_ERROR	1
# define LIBNN_DATA_SIZE_ERROR	2
# define LIBNN_OPEN_ERROR	3
# define LIBNN_READ_ERROR	4
# define LIBNN_WRITE_ERROR	5

void	*xmalloc(unsigned size);
void	*xfopen(const char *name, const char *flags);
void	xfread(void *dest, unsigned size, unsigned nb, FILE *file);
void	xfwrite(void *dest, unsigned size, unsigned nb, FILE *file);

double	minimum(double a, double b);
double	maximum(double a, double b);
double	sign(double a);
double	xfabs(double a);


char   	*toupper_string(char *string);

#endif /* !COMMON_H_ */
