/******************************************************************************
** Project: neural_network
** Filename: rprop.c
*******************************************************************************
** Authors: A. BAILLARD & T. BAUDLOT
** Creation date: 14/07/03
** Last modification date:
*******************************************************************************
** Comments:
** 14/07/03	AB	Prototypes
******************************************************************************/

#ifndef _RPROP_H_
# define _RPROP_H_

# define PREVIOUS	0
# define CURRENT       	1

# define N_PLUS		1.2
# define N_MINUS	0.5
# define DELTA_0	0.1
# define DELTA_MAX	50
# define DELTA_MIN	0.000001

# include <gsl/gsl_matrix_float.h>

int		rprop(t_network *network, unsigned base_dim,
		      double **input_base, unsigned n_input,
		      double **expected_base, unsigned n_output);

int		gsl_rprop(t_network *network, unsigned nb_samples,
			  const gsl_matrix_float *input, const gsl_matrix_float *output);

#endif /* !_RPROP_H_ */
