/******************************************************************************
** Project: neural_network
** Filename: rprop_vec.c
*******************************************************************************
** Authors: A. BAILLARD & T. BAUDLOT
** Creation date: 18/07/03
** Last modification date: 18/07/03
*******************************************************************************
** Comments:
** 18/07/03	AB	Prototypes
******************************************************************************/

#ifndef RPROP_VEC_H_
# define RPROP_VEC_H_

typedef struct		s_rprop_vec
{
  double	**e_g_h_w[2];
  double	**e_g_o_w[2];
  double	*e_g_h_b[2];
  double	*e_g_o_b[2];

  double	**d_t_h_w;
  double	**d_t_o_w;
  double	*d_t_h_b;
  double	*d_t_o_b;

  double	**d_h_w;
  double	**d_o_w;
  double	*d_h_b;
  double	*d_o_b;
}		t_rprop_vec;

void	create_rprop_vectors(t_network *network, t_rprop_vec *vectors);
void	delete_rprop_vectors(t_network *network, t_rprop_vec *vectors);
void	init_rprop_vectors(t_network *netowrk, t_rprop_vec *vectors);

void   	init_current_grads(t_network *network, t_rprop_vec *vectors);
void   	compute_energy_grads(t_network *network, t_rprop_vec *vectors, double *input_sample);
void	save_energy_grads(t_network *network, t_rprop_vec *vectors);

#endif /* !RPROP_VEC_H_ */
