///////////////////////////////////////////////////////////////////////////////
// Project: defectix 
// Filename: halosimulator.hh
// Directory: src
///////////////////////////////////////////////////////////////////////////////
// Authors: A. BAILLARD
// Creation date: 21/01/04
// Last modification date: 30/06/04
///////////////////////////////////////////////////////////////////////////////
// Comments:
// 21/01/04	Virtual class AstronomicDefectAdder
// 27/01/04	Add function createRectangle() to add a defect
// 28/01/04	Doxygen header
// 29/01/04	Add createSVMOutputFile() (ugly basic version)
// 05/02/04	Modify function to unuse CCfits
// 26/02/04	Update doxygen header
// 09/03/04	Remove createSVMOutputFile()
// 10/03/04	Update to astrosimulator.hh and AstronomicDefectSimulator
// 15/03/04	Update error management *
//		Clean code
//		Move doxygen header to astrosimulator.dox
// 18/03/04	Copy code to astrosimulator.cc
// 30/06/04	Update to halosimulator.hh
///////////////////////////////////////////////////////////////////////////////

#ifndef TRAILSIMULATOR_H_
# define TRAILSIMULATOR_H_

# include <string>
# include <time.h>
# include <iostream.h>
# include <fstream.h>
# include "simulator.hh"

using namespace DefectixError;

class	TrailSimulator: public DefectSimulator
{
  /////////////////////////////////////////////////////////////////////////////
  // functions in trailsimulator.cc					     //
  /////////////////////////////////////////////////////////////////////////////
public:
  TrailSimulator(const DefectixOptions::Options& options);

private:
  void		createDefect(gsl_matrix_float *src, gsl_matrix_float *mask, int extend);

};
  
#endif /* !TRAILSIMULATOR_H_ */
